# coding: utf-8
"""
HCE project,  Python bindings, Distributed Tasks Manager application.
Exceptions module content exceptions for crawler module

@package: dc_crawler
@file Exceptions.py
@author: Alexander Vybornyh <alexander.hce.cluster@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2018 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
"""

import app.Consts as APP_CONSTS


class TimeoutException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class ConnectionErrorException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class HTTPErrorException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class URLRequiredException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class SyncronizeException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class CrawlerException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class InternalCrawlerException(Exception):
  def __init__(self, message):
    Exception.__init__(self, message)


class CrawlerFilterException(Exception):
  def __init__(self, message, code=APP_CONSTS.ERROR_CRAWLER_FILTERS_BREAK, response=None):
    Exception.__init__(self, message)
    self.code = code
    self.response = response


class BadStatusCodeException(CrawlerFilterException):
  def __init__(self, message, code=APP_CONSTS.ERROR_BAD_STATUS_CODE, response=None):
    CrawlerFilterException.__init__(self, message, code, response)


class BadContentTypeException(CrawlerFilterException):
  def __init__(self, message, code=APP_CONSTS.ERROR_MASK_SITE_UNSUPPORTED_CONTENT_TYPE, response=None):
    CrawlerFilterException.__init__(self, message, code, response)


class TooManyRedirectsException(CrawlerFilterException):
  def __init__(self, message, code=APP_CONSTS.ERROR_FETCH_TOO_MANY_REDIRECTS, response=None):
    CrawlerFilterException.__init__(self, message, code, response)


class TooManyHTTPRedirectsException(TooManyRedirectsException):
  def __init__(self, message, code=APP_CONSTS.ERROR_MAX_ALLOW_HTTP_REDIRECTS, response=None):
    TooManyRedirectsException.__init__(self, message, code, response)


class TooManyHTMLRedirectsException(TooManyRedirectsException):
  def __init__(self, message, code=APP_CONSTS.ERROR_MAX_ALLOW_HTML_REDIRECTS, response=None):
    TooManyRedirectsException.__init__(self, message, code, response)


class NotModifiedException(Exception):
  def __init__(self, message, detectModified=None, response=None):
    Exception.__init__(self, message)
    self.detectModified = detectModified
    self.response = response
